The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::PoleZero Class Reference

STK one-pole, one-zero filter class. More...

`#include <PoleZero.h>`

Inheritance diagram for stk::PoleZero:

## Public Member Functions
| PoleZero ()
| Default constructor creates a first-order pass-through filter.
| ~PoleZero ()
| Class destructor.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setB1 (StkFloat b1)
| Set the b[1] coefficient value.
void | setA1 (StkFloat a1)
| Set the a[1] coefficient value.
void | setCoefficients (StkFloat b0, StkFloat b1, StkFloat a1, bool clearState=false)
| Set all filter coefficients.
void | setAllpass (StkFloat coefficient)
| Set the filter for allpass behavior using coefficient.
void | setBlockZero (StkFloat thePole=0.99)
| Create a DC blocking filter with the given pole position in the z-plane.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
Public Member Functions inherited from stk::Filter
| Filter (void)
| Class constructor.
unsigned int | channelsIn (void) const
| Return the number of input channels for the class.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
virtual void | clear (void)
| Clears all internal states of the filter.
void | setGain (StkFloat gain)
| Set the filter gain.
StkFloat | getGain (void) const
| Return the current filter gain.
StkFloat | phaseDelay (StkFloat frequency)
| Return the filter phase delay at the specified frequency.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK one-pole, one-zero filter class.

This class implements a one-pole, one-zero digital filter. A method is provided for creating an allpass filter with a given coefficient. Another method is provided to create a DC blocking filter.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Function Documentation

## ◆ setAllpass()

void stk::PoleZero::setAllpass | ( | StkFloat | coefficient | ) |

Set the filter for allpass behavior using coefficient.

This method uses coefficient to create an allpass filter, which has unity gain at all frequencies. Note that the coefficient magnitude must be less than one to maintain filter stability.

## ◆ setBlockZero()

void stk::PoleZero::setBlockZero | ( | StkFloat | thePole = `0.99` | ) |

Create a DC blocking filter with the given pole position in the z-plane.

This method sets the given pole position, together with a zero at z=1, to create a DC blocking filter. The argument magnitude should be close to (but less than) one to minimize low-frequency attenuation.

## ◆ tick()

StkFrames & stk::PoleZero::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

90{
91#if defined(_STK_DEBUG_)
92 if ( channel >= frames.channels() ) {
93 oStream_ << "PoleZero::tick(): channel and StkFrames arguments are incompatible!";
94 handleError( StkError::FUNCTION_ARGUMENT );
95 }
96#endif
97
98 StkFloat *samples = &frames[channel];
99 unsigned int hop = frames.channels();
100 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
101 inputs_[0] = gain_ * *samples;
102 *samples = b_[0] * inputs_[0] + b_[1] * inputs_[1] - a_[1] * outputs_[1];
103 inputs_[1] = inputs_[0];
104 outputs_[1] = *samples;
105 }
106
107 lastFrame_[0] = outputs_[1];
108 return frames;
109}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The documentation for this class was generated from the following file:

- PoleZero.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.